#ifndef _INCLUDE_LINUX_SW_WATCHDOG_H_
#define _INCLUDE_LINUX_SW_WATCHDOG_H_

enum {
	SW_WATCHDOG_DISABLED=0,
	SW_WATCHDOG_SCHED,
	SW_WATCHDOG_NOSCHED,
};

extern unsigned int sw_watchdog_state;
extern int sw_watchdog_fl_irq; /* First level IRQ */

static inline void sw_watchdog_irq_enter(int cpu, int irq) {
	if(local_irq_count(cpu) == 1) {
		sw_watchdog_fl_irq=irq;
	}
}
	
static inline void sw_watchdog_reset(void) {
	if( sw_watchdog_state != SW_WATCHDOG_DISABLED)
		sw_watchdog_state=SW_WATCHDOG_NOSCHED;
}

static inline void sw_watchdog_ok(void) {
	sw_watchdog_state=SW_WATCHDOG_SCHED;
}

static inline int sw_watchdog_fire(void) {
	return ( sw_watchdog_state == SW_WATCHDOG_NOSCHED );
}

#endif
